"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const codegen_ui_1 = require("@aws-amplify/codegen-ui");
const typescript_1 = require("typescript");
const react_component_renderer_1 = require("../react-component-renderer");
const react_component_render_helper_1 = require("../react-component-render-helper");
class CollectionRenderer extends react_component_renderer_1.ReactComponentRenderer {
    renderElement(renderChildren) {
        var _a, _b;
        this.addKeyPropertyToChildren((_a = this.component.children) !== null && _a !== void 0 ? _a : []);
        const childrenJsx = this.component.children ? renderChildren((_b = this.component.children) !== null && _b !== void 0 ? _b : []) : [];
        const arrowFuncExpr = this.renderItemArrowFunctionExpr(childrenJsx);
        const itemsVariableName = this.findItemsVariableName();
        const element = typescript_1.factory.createJsxElement(this.renderCollectionOpeningElement(itemsVariableName), [arrowFuncExpr], typescript_1.factory.createJsxClosingElement(typescript_1.factory.createIdentifier(this.component.componentType)));
        this.importCollection.addImport('@aws-amplify/ui-react', this.component.componentType);
        return element;
    }
    renderCollectionOpeningElement(itemsVariableName) {
        const propsArray = Object.entries(this.component.properties).map(([key, value]) => (0, react_component_render_helper_1.buildOpeningElementProperties)(this.componentMetadata, value, key));
        const itemsAttribute = typescript_1.factory.createJsxAttribute(typescript_1.factory.createIdentifier('items'), typescript_1.factory.createJsxExpression(undefined, typescript_1.factory.createBinaryExpression(typescript_1.factory.createIdentifier(itemsVariableName || 'items'), typescript_1.factory.createToken(typescript_1.SyntaxKind.BarBarToken), typescript_1.factory.createArrayLiteralExpression([], false))));
        propsArray.push(itemsAttribute);
        this.addPropsSpreadAttributes(propsArray);
        return typescript_1.factory.createJsxOpeningElement(typescript_1.factory.createIdentifier(this.component.componentType), undefined, typescript_1.factory.createJsxAttributes(propsArray));
    }
    addKeyPropertyToChildren(children) {
        children.forEach((child) => {
            if ('key' in child.properties) {
                return;
            }
            // eslint-disable-next-line no-param-reassign
            child.properties.key = {
                collectionBindingProperties: {
                    property: '',
                    field: 'id',
                },
            };
        });
    }
    findItemsVariableName() {
        var _a;
        if ((0, codegen_ui_1.isStudioComponentWithCollectionProperties)(this.component)) {
            const collectionProps = Object.entries((_a = this.component.collectionProperties) !== null && _a !== void 0 ? _a : {});
            return collectionProps.length > 0 ? collectionProps[0][0] : undefined;
        }
        return undefined;
    }
    renderItemArrowFunctionExpr(childrenJsx) {
        return typescript_1.factory.createJsxExpression(undefined, typescript_1.factory.createArrowFunction(undefined, undefined, [
            typescript_1.factory.createParameterDeclaration(undefined, undefined, undefined, typescript_1.factory.createIdentifier('item'), undefined, undefined, undefined),
            typescript_1.factory.createParameterDeclaration(undefined, undefined, undefined, typescript_1.factory.createIdentifier('index'), undefined, undefined, undefined),
        ], undefined, typescript_1.factory.createToken(typescript_1.SyntaxKind.EqualsGreaterThanToken), typescript_1.factory.createParenthesizedExpression(childrenJsx[0])));
    }
}
exports.default = CollectionRenderer;
//# sourceMappingURL=collection.js.map