import { FieldConfigMetadata } from '@aws-amplify/codegen-ui/lib/types';
import { Statement, VariableStatement, ExpressionStatement } from 'typescript';
export declare const buildDataStoreExpression: (dataStoreActionType: 'update' | 'create', modelName: string, importedModelName: string, fieldConfigs: Record<string, FieldConfigMetadata>, thisModelPrimaryKey: string) => (ExpressionStatement | VariableStatement)[];
/**
  example: const validationResponses = await Promise.all(
    Object.keys(validations).reduce((promises, fieldName) => {
      if (Array.isArray(modelFields[fieldName])) {
        promises.push(
          ...modelFields[fieldName].map((item) =>
            runValidationTasks(fieldName, item, getDisplayValue[fieldName]),
          ),
        );
        return promises;
      }
      promises.push(runValidationTasks(fieldName, modelFields[fieldName], getDisplayValue[fieldName]));
      return promises;
    }, []),
  );
  if (validationResponses.some((r) => r.hasError)) {
    return;
  }
*/
export declare const onSubmitValidationRun: (shouldUseGetDisplayValue?: boolean | undefined) => (VariableStatement | import("typescript").IfStatement)[];
export declare const buildUpdateDatastoreQuery: (dataTypeName: string, recordName: string, relatedModelStatements: Statement[], primaryKey: string) => (ExpressionStatement | VariableStatement)[];
