import { ComponentRendererBase, StudioNode, StudioComponent, StudioComponentChild, ComponentMetadata } from '@aws-amplify/codegen-ui';
import { JsxAttributeLike, JsxElement, JsxOpeningElement, JsxSelfClosingElement, JsxChild } from 'typescript';
import { ImportCollection } from './imports';
export declare class ReactComponentRenderer<TPropIn> extends ComponentRendererBase<TPropIn, JsxElement | JsxSelfClosingElement, JsxChild> {
    protected componentMetadata: ComponentMetadata;
    protected importCollection: ImportCollection;
    protected parent?: StudioNode | undefined;
    constructor(component: StudioComponent | StudioComponentChild, componentMetadata: ComponentMetadata, importCollection: ImportCollection, parent?: StudioNode | undefined);
    renderElement(renderChildren?: ((children: StudioComponentChild[]) => JsxChild[]) | undefined): JsxElement | JsxSelfClosingElement;
    protected renderOpeningElement(): JsxOpeningElement;
    protected addPropsSpreadAttributes(attributes: JsxAttributeLike[]): void;
    private addGetOverridePropsAttribute;
    private addCollectionOverridePropsAttribute;
}
