import { StudioTemplateRenderer, StudioSchema } from '@aws-amplify/codegen-ui';
import { ReactRenderConfig } from './react-render-config';
import { ImportCollection } from './imports';
import { ReactOutputManager } from './react-output-manager';
import { defaultRenderConfig } from './react-studio-template-renderer-helper';
import { RequiredKeys } from './utils/type-utils';
export declare class ReactIndexStudioTemplateRenderer extends StudioTemplateRenderer<string, StudioSchema[], ReactOutputManager, {
    componentText: string;
    renderComponentToFilesystem: (outputPath: string) => Promise<void>;
}> {
    protected importCollection: ImportCollection;
    protected renderConfig: RequiredKeys<ReactRenderConfig, keyof typeof defaultRenderConfig>;
    fileName: string;
    constructor(schemas: StudioSchema[], renderConfig: ReactRenderConfig);
    renderComponentInternal(): {
        componentText: string;
        renderComponentToFilesystem: (outputPath: string) => Promise<void>;
    };
    private buildExports;
    validateSchema(): void;
}
