import { StudioTemplateRenderer } from '@aws-amplify/codegen-ui';
import { ReactRenderConfig } from './react-render-config';
import { ImportCollection } from './imports';
import { ReactOutputManager } from './react-output-manager';
import { RequiredKeys } from './utils/type-utils';
import { defaultRenderConfig } from './react-studio-template-renderer-helper';
export declare type UtilTemplateType = 'validation' | 'formatter' | 'fetchByPath';
export declare class ReactUtilsStudioTemplateRenderer extends StudioTemplateRenderer<string, UtilTemplateType[], ReactOutputManager, {
    componentText: string;
    renderComponentToFilesystem: (outputPath: string) => Promise<void>;
}> {
    protected importCollection: ImportCollection;
    protected renderConfig: RequiredKeys<ReactRenderConfig, keyof typeof defaultRenderConfig>;
    fileName: string;
    utils: UtilTemplateType[];
    constructor(utils: UtilTemplateType[], renderConfig: ReactRenderConfig);
    renderComponentInternal(): {
        componentText: string;
        renderComponentToFilesystem: (outputPath: string) => Promise<void>;
    };
    validateSchema(): void;
}
