/**
 * accepts timestamp number and returns date object
 * since datastore allows second and millisecond epochs we need to format accordingly
 *
 * @param ts number
 * @returns date object
 */
export declare const convertTimeStampToDate: (ts: number) => Date;
/**
 * takes a date object and converts it to the local format used for an html input element with datetime-local
 *
 * @param date date object
 * @returns string formatted in datetime-local
 */
export declare const convertToLocal: (date: Date) => string;
/**
 * ast representation fo the convert timestamp to date
 */
export declare const convertTimeStampToDateAST: import("typescript").VariableStatement;
/**
 * convertToLocal function represented in ts ast
 */
export declare const convertToLocalAST: import("typescript").VariableStatement;
