"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addUseEffectWrapper = void 0;
/*
  Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.

  Licensed under the Apache License, Version 2.0 (the "License").
  You may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
const typescript_1 = require("typescript");
const addUseEffectWrapper = (statements, dependencies) => {
    return typescript_1.factory.createExpressionStatement(typescript_1.factory.createCallExpression(typescript_1.factory.createIdentifier('React.useEffect'), undefined, [
        typescript_1.factory.createArrowFunction(undefined, undefined, [], undefined, typescript_1.factory.createToken(typescript_1.SyntaxKind.EqualsGreaterThanToken), typescript_1.factory.createBlock(statements, true)),
        typescript_1.factory.createArrayLiteralExpression(dependencies.map((dependency) => typescript_1.factory.createIdentifier(dependency)), false),
    ]));
};
exports.addUseEffectWrapper = addUseEffectWrapper;
//# sourceMappingURL=generate-react-hooks.js.map